// Character and enemy information class

/*
   include all BMP files, positions,  and stats.*/

#ifndef INFO_H
#define INFO_H

#include "Sprite.h"
#include "SDL.h"

class Info
{
  private:
		SDL_Surface *playerUpImage, *playerDownImage, *playerLeftImage, *playerRightImage;
		SDL_Surface *zombieUpImage, *zombieDownImage, *zombieLeftImage, *zombieRightImage;
		int playerXpos, playerYpos;
		int numberOfZombies;
		int zombieXpos, zombieYpos;
		bool zombieThere;
		bool playerInRange;
		double distance;
		int areaNumber;

		int playerDirection, zombieDirection;

		int health, zombieHealth;

	public:
		void Init();

		void setPosition(char, int, int);
		void initImages(char);

		void setAreaNumber(int);
		int returnAreaNumber();
		
		void setHealth(char, int);
		int returnHealth(char);
		
		void setPlayerInRange(bool);
		bool returnPlayerInRange();
		
		void setDistance(char, double);
		double returnDistance();

		void setNumberOfZombies(int);
		int returnNumberOfZombies();

		void setImage(char, int, SDL_Surface*);
		SDL_Surface* returnImage(char, int);

		void setDirection(char, int);
		int returnDirection(char);

		bool returnZombieThere();

		bool canHitEnemy(int, int, int, int);
};

#endif